/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    (function (AADAppName) {
        AADAppName[AADAppName["api"] = 0] = "api";
        AADAppName[AADAppName["opstool"] = 1] = "opstool";
        AADAppName[AADAppName["monitoring"] = 2] = "monitoring";
        AADAppName[AADAppName["rdpclient"] = 3] = "rdpclient";
        AADAppName[AADAppName["ampdash"] = 4] = "ampdash";
        AADAppName[AADAppName["pstool"] = 5] = "pstool";
    })(AmpCoreApi.AADAppName || (AmpCoreApi.AADAppName = {}));
    var AADAppName = AmpCoreApi.AADAppName;
    var Services;
    (function (Services) {
        var AmpAADAppService = (function () {
            function AmpAADAppService(httpService) {
                this._routePrefix = "/api/aad/apps";
                this._httpService = httpService;
            }
            AmpAADAppService.prototype.listAADApps = function () {
                return this._httpService.listResources(this._routePrefix);
            };
            AmpAADAppService.prototype.getAADApp = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpAADAppService.prototype.createAADApp = function (aadApp) {
                return this._httpService.createResource(this._routePrefix, aadApp);
            };
            AmpAADAppService.prototype.deleteAADApp = function (id) {
                return this._httpService.deleteResource(this._routePrefix + "/" + id);
            };
            AmpAADAppService.prototype.getAADAppByName = function (name) {
                return this._httpService.getResource(this._routePrefix + "?name=" + name);
            };
            AmpAADAppService.IID = "AmpAADAppService";
            AmpAADAppService.$inject = ["AmpHttpService"];
            return AmpAADAppService;
        }());
        Services.AmpAADAppService = AmpAADAppService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpAADWebsiteService = (function () {
            function AmpAADWebsiteService(httpService) {
                this._routePrefix = "/api/aad/websites";
                this._httpService = httpService;
            }
            AmpAADWebsiteService.prototype.listAADWebsites = function () {
                return this._httpService.listResources(this._routePrefix);
            };
            AmpAADWebsiteService.prototype.getAADWebsite = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpAADWebsiteService.prototype.createAADWebsite = function (aadWebsite) {
                return this._httpService.createResource(this._routePrefix, aadWebsite);
            };
            AmpAADWebsiteService.prototype.deleteAADWebsite = function (id) {
                return this._httpService.deleteResource(this._routePrefix + "/" + id);
            };
            AmpAADWebsiteService.IID = "AmpAADWebsiteService";
            AmpAADWebsiteService.$inject = ["AmpHttpService"];
            return AmpAADWebsiteService;
        }());
        Services.AmpAADWebsiteService = AmpAADWebsiteService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpAccountService = (function () {
            function AmpAccountService(httpService) {
                this._routePrefix = "/api/accounts";
                this._httpService = httpService;
            }
            AmpAccountService.prototype.listAccounts = function () {
                return this._httpService.listResources(this._routePrefix);
            };
            AmpAccountService.prototype.getAccount = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpAccountService.prototype.createAccount = function (account) {
                return this._httpService.createResource(this._routePrefix, account);
            };
            AmpAccountService.prototype.updateAccount = function (account) {
                return this._httpService.updateResource(this._routePrefix + "/" + account.id, account);
            };
            AmpAccountService.prototype.deleteAccount = function (id) {
                return this._httpService.deleteResource(this._routePrefix + "/" + id);
            };
            AmpAccountService.IID = "AmpAccountService";
            AmpAccountService.$inject = ["AmpHttpService"];
            return AmpAccountService;
        }());
        Services.AmpAccountService = AmpAccountService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpAzureService = (function () {
            function AmpAzureService(httpService) {
                this._routePrefix = "/api/azure";
                this._httpService = httpService;
            }
            AmpAzureService.prototype.listAzureLocations = function () {
                return this._httpService.listResources(this._routePrefix + "/locations");
            };
            AmpAzureService.prototype.getAzureWebsiteInfo = function () {
                return this._httpService.getResource(this._routePrefix + "/websiteinfo");
            };
            AmpAzureService.IID = "AmpAzureService";
            AmpAzureService.$inject = ["AmpHttpService"];
            return AmpAzureService;
        }());
        Services.AmpAzureService = AmpAzureService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpBundleService = (function () {
            function AmpBundleService(httpService) {
                this._routePrefix = "/api/bundles";
                this._httpService = httpService;
            }
            AmpBundleService.prototype.listBundles = function () {
                return this._httpService.listResources(this._routePrefix);
            };
            AmpBundleService.prototype.listBundlesPrefetch = function () {
                return this._httpService.listResources(this._routePrefix + "/prefetch");
            };
            AmpBundleService.prototype.getBundle = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpBundleService.prototype.createBundle = function (bundle) {
                return this._httpService.createResource(this._routePrefix, bundle);
            };
            AmpBundleService.prototype.updateBundle = function (bundle, comment) {
                return this._httpService.updateResource(this._routePrefix + "/" + bundle.id + (comment ? "?comment=" + comment : ""), bundle);
            };
            AmpBundleService.prototype.deleteBundle = function (id) {
                return this._httpService.deleteResource(this._routePrefix + "/" + id);
            };
            AmpBundleService.prototype.getBundlePackageUrl = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id + "/export");
            };
            AmpBundleService.prototype.getBundlePrefetch = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id + "/prefetch");
            };
            AmpBundleService.prototype.upsertBundleDependencies = function (id, dependencies) {
                return this._httpService.postResourceDifferentOutput(this._routePrefix + "/" + id + "/dependsOn", dependencies);
            };
            AmpBundleService.IID = "AmpBundleService";
            AmpBundleService.$inject = ["AmpHttpService"];
            return AmpBundleService;
        }());
        Services.AmpBundleService = AmpBundleService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpCoreSecurityGroupService = (function () {
            function AmpCoreSecurityGroupService(httpService) {
                this._routePrefix = "/api/coresgs";
                this._httpService = httpService;
            }
            AmpCoreSecurityGroupService.prototype.listCoreSecurityGroups = function () {
                return this._httpService.listResources(this._routePrefix);
            };
            AmpCoreSecurityGroupService.prototype.getCoreSecurityGroup = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpCoreSecurityGroupService.prototype.createCoreSecurityGroup = function (coreSg) {
                return this._httpService.createResource(this._routePrefix, coreSg);
            };
            AmpCoreSecurityGroupService.prototype.updateCoreSecurityGroup = function (coreSg) {
                return this._httpService.updateResource(this._routePrefix + "/" + coreSg.id, coreSg);
            };
            AmpCoreSecurityGroupService.prototype.deleteCoreSecurityGroup = function (id) {
                return this._httpService.deleteResource(this._routePrefix + "/" + id);
            };
            AmpCoreSecurityGroupService.prototype.listCoreSecurityGroupsByTenant = function (tenantId) {
                return this._httpService.listResources(this._routePrefix + "?tenantId=" + tenantId);
            };
            AmpCoreSecurityGroupService.IID = "AmpCoreSecurityGroupService";
            AmpCoreSecurityGroupService.$inject = ["AmpHttpService"];
            return AmpCoreSecurityGroupService;
        }());
        Services.AmpCoreSecurityGroupService = AmpCoreSecurityGroupService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpCredentialService = (function () {
            function AmpCredentialService($rsp) {
                this.routePrefix = "vault/api/credentials";
                this.$rsp = $rsp;
            }
            AmpCredentialService.prototype.list = function (siteId) {
                return this.$rsp.listResources(siteId, this.routePrefix);
            };
            AmpCredentialService.prototype.create = function (siteId, c) {
                return this.$rsp.postResources(siteId, this.routePrefix, c);
            };
            AmpCredentialService.prototype.update = function (siteId, c) {
                return this.$rsp.putResources(siteId, this.routeToId(c.id), c);
            };
            AmpCredentialService.prototype.remove = function (siteId, id) {
                return this.$rsp.deleteResource(siteId, this.routeToId(id));
            };
            AmpCredentialService.prototype.get = function (siteId, id) {
                return this.$rsp.getResource(siteId, this.routeToId(id));
            };
            AmpCredentialService.prototype.sync = function (siteId) {
                return this.$rsp.postResources(siteId, this.routePrefix + "/sync", null);
            };
            AmpCredentialService.prototype.listAll = function (siteId) {
                return this.$rsp.listResources(siteId, this.routePrefix + "/all");
            };
            AmpCredentialService.prototype.routeToId = function (id) { return this.routePrefix + "/" + id; };
            AmpCredentialService.IID = "AmpCredentialService";
            AmpCredentialService.$inject = ["AmpSiteProxyService"];
            return AmpCredentialService;
        }());
        Services.AmpCredentialService = AmpCredentialService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    (function (UserRoles) {
        UserRoles[UserRoles["CoreCanCreate"] = 0] = "CoreCanCreate";
        UserRoles[UserRoles["CoreCanDelete"] = 1] = "CoreCanDelete";
        UserRoles[UserRoles["CoreAdmin"] = 2] = "CoreAdmin";
        UserRoles[UserRoles["OpsAdmin"] = 3] = "OpsAdmin";
        UserRoles[UserRoles["EditSiteAccess"] = 4] = "EditSiteAccess";
    })(AmpCoreApi.UserRoles || (AmpCoreApi.UserRoles = {}));
    var UserRoles = AmpCoreApi.UserRoles;
    var Services;
    (function (Services) {
        var AmpDirectoryService = (function () {
            function AmpDirectoryService($qService, httpService) {
                this._routePrefix = "/api/dir";
                this._httpService = httpService;
                this._qService = $qService;
            }
            AmpDirectoryService.prototype.me = function () {
                var deferred = this._qService.defer();
                this._httpService.getResource(this._routePrefix + "/me")
                    .then(function (response) {
                    if (response == null) {
                        deferred.reject("Could not return user information. Response was null.");
                        return;
                    }
                    if (response.thumbnailPhoto && "data:image/jpeg;base64," !== response.thumbnailPhoto.slice(0, 23)) {
                        response.thumbnailPhoto = "data:image/jpeg;base64," + response.thumbnailPhoto;
                    }
                    deferred.resolve(response);
                }, function (callbackArgs) {
                    deferred.reject(callbackArgs);
                });
                return deferred.promise;
            };
            AmpDirectoryService.prototype.getDirectory = function () {
                return this._httpService.getResource(this._routePrefix);
            };
            AmpDirectoryService.prototype.getSecurityGroups = function (displayNameFilter) {
                if (displayNameFilter) {
                    return this._httpService.getResource(this._routePrefix + "/sgs?dnFilter=" + displayNameFilter);
                }
                return this._httpService.listResources(this._routePrefix + "/sgs");
            };
            AmpDirectoryService.prototype.getSecurityGroup = function (id) {
                return this._httpService.getResource(this._routePrefix + "/sgs/" + id);
            };
            AmpDirectoryService.IID = "AmpDirectoryService";
            AmpDirectoryService.$inject = ["$q", "AmpHttpService"];
            return AmpDirectoryService;
        }());
        Services.AmpDirectoryService = AmpDirectoryService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpHttpService = (function () {
            function AmpHttpService($http, $q) {
                this._httpService = $http;
                this._qService = $q;
                this._uriBase = "";
            }
            AmpHttpService.prototype.setBaseAddress = function (uri) {
                var n = uri.length;
                this._uriBase = n > 1 && uri[n - 1] === "/" ? uri.substring(0, n - 1) : uri;
            };
            AmpHttpService.prototype.getBaseAddress = function () {
                return this._uriBase;
            };
            AmpHttpService.prototype.listResources = function (uri) {
                var deferred = this._qService.defer();
                this._httpService.get(this._uriBase + uri)
                    .then(function (response) {
                    deferred.resolve(response ? response.data : response);
                }, function (callbackArgs) {
                    deferred.reject(callbackArgs);
                });
                return deferred.promise;
            };
            AmpHttpService.prototype.getResource = function (uri) {
                var deferred = this._qService.defer();
                this._httpService.get(this._uriBase + uri)
                    .then(function (response) {
                    deferred.resolve(response ? response.data : response);
                }, function (callbackArgs) {
                    deferred.reject(callbackArgs);
                });
                return deferred.promise;
            };
            AmpHttpService.prototype.createResource = function (uri, data) {
                return this.postResource(uri, data);
            };
            AmpHttpService.prototype.updateResource = function (uri, data) {
                return this.putResource(uri, data);
            };
            AmpHttpService.prototype.deleteResource = function (uri) {
                var deferred = this._qService.defer();
                this._httpService.delete(this._uriBase + uri)
                    .then(function () {
                    deferred.resolve();
                }, function (callbackArgs) {
                    deferred.reject(callbackArgs);
                });
                return deferred.promise;
            };
            AmpHttpService.prototype.postResource = function (uri, data) {
                var deferred = this._qService.defer();
                this._httpService.post(this._uriBase + uri, data)
                    .then(function (response) {
                    deferred.resolve(response ? response.data : response);
                }, function (callbackArgs) {
                    deferred.reject(callbackArgs);
                });
                return deferred.promise;
            };
            AmpHttpService.prototype.postResourceDifferentOutput = function (uri, data) {
                var deferred = this._qService.defer();
                this._httpService.post(this._uriBase + uri, data)
                    .then(function (response) {
                    deferred.resolve(response ? response.data : response);
                }, function (callbackArgs) {
                    deferred.reject(callbackArgs);
                });
                return deferred.promise;
            };
            AmpHttpService.prototype.putResource = function (uri, data) {
                var deferred = this._qService.defer();
                this._httpService.put(this._uriBase + uri, data)
                    .then(function () {
                    deferred.resolve();
                }, function (callbackArgs) {
                    deferred.reject(callbackArgs);
                });
                return deferred.promise;
            };
            AmpHttpService.prototype.putResourceWithResponse = function (uri, data) {
                var deferred = this._qService.defer();
                this._httpService.put(this._uriBase + uri, data)
                    .then(function (response) {
                    deferred.resolve(response ? response.data : response);
                }, function (callbackArgs) {
                    deferred.reject(callbackArgs);
                });
                return deferred.promise;
            };
            AmpHttpService.prototype.linkResources = function (uri) {
                return this.putResource(uri, null);
            };
            AmpHttpService.prototype.unlinkResources = function (uri) {
                var deferred = this._qService.defer();
                this._httpService.delete(this._uriBase + uri)
                    .then(function () {
                    deferred.resolve();
                }, function (callbackArgs) {
                    deferred.reject(callbackArgs);
                });
                return deferred.promise;
            };
            AmpHttpService.makeQueryString = function (prefix, vars) {
                var q = "";
                for (var key in vars) {
                    if (vars.hasOwnProperty(key) && vars[key] !== undefined && vars[key] !== null) {
                        q += (q ? "&" : "?") + encodeURIComponent(key) + "=" + encodeURIComponent(vars[key]);
                    }
                }
                return prefix + q;
            };
            AmpHttpService.IID = "AmpHttpService";
            AmpHttpService.$inject = ["$http", "$q"];
            return AmpHttpService;
        }());
        Services.AmpHttpService = AmpHttpService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpInsightsService = (function () {
            function AmpInsightsService() {
            }
            AmpInsightsService.prototype.configure = function (config) {
                this.appInsights = window.appInsights || (function (aiConfig) {
                    var appInsights = {
                        config: aiConfig
                    };
                    // Assigning these to local variables allows them to be minified to save space:
                    var localDocument = document;
                    var localWindow = window;
                    var scriptText = "script";
                    var scriptElement = localDocument.createElement(scriptText);
                    scriptElement.src = aiConfig.url || "//az416426.vo.msecnd.net/scripts/a/ai.0.js";
                    localDocument.getElementsByTagName(scriptText)[0].parentNode.appendChild(scriptElement);
                    // capture initial cookie
                    appInsights.cookie = localDocument.cookie;
                    appInsights.queue = [];
                    var createLazyMethod = function (name) {
                        // Define a temporary method that queues-up a the real method call
                        appInsights[name] = function () {
                            // Capture the original arguments passed to the method
                            var originalArguments = arguments;
                            // Queue-up a call to the real method
                            appInsights.queue.push(function () {
                                // Invoke the real method with the captured original arguments
                                appInsights[name].apply(appInsights, originalArguments);
                            });
                        };
                    };
                    var method = ["Event", "Exception", "Metric", "PageView", "Trace", "Ajax"];
                    while (method.length) {
                        createLazyMethod("track" + method.pop());
                    }
                    createLazyMethod("setAuthenticatedUserContext");
                    createLazyMethod("clearAuthenticatedUserContext");
                    // collect global errors
                    if (!aiConfig.disableExceptionTracking) {
                        method = "onerror";
                        createLazyMethod("_" + method);
                        var originalOnError = localWindow[method];
                        localWindow[method] = function (message, url, lineNumber, columnNumber, error) {
                            var handled = originalOnError && originalOnError(message, url, lineNumber, columnNumber, error);
                            if (handled !== true) {
                                appInsights["_" + method](message, url, lineNumber, columnNumber, error);
                            }
                            return handled;
                        };
                    }
                    return appInsights;
                })(config);
                // global instance must be set in this order to mitigate issues in ie8 and lower
                window.appInsights = this.appInsights;
                //this.appInsights.trackPageView(pageName, window.location.hostname);
            };
            //#region ApplicationInsights Methods
            /**
            * Logs that a page or similar container was displayed to the user.
            * @param {string} name The name used to identify the page in the portal. Defaults to the document title.
            * @param {string} url A relative or absolute URL that identifies the page or similar item. Defaults to the window location.
            * @param {{[string]:string}} properties Map of string to string: Additional data used to filter pages in the portal. Defaults to empty.
            * @param {{[string]:number}} measurements Map of string to number: Metrics associated with this page, displayed in Metrics Explorer on the portal. Defaults to empty.
            */
            AmpInsightsService.prototype.trackPageView = function (name, url, properties, measurements) {
                this.appInsights.trackPageView(name, url, properties, measurements);
            };
            /**
            * Logs that a page or similar container was displayed to the user.
            * @param {string} name A string that identifies the metric. In the portal, you can select metrics for display by name.
            * @param {number} average Either a single measurement, or the average of several measurements. Should be >=0 to be correctly displayed.
            * @param {number} sampleCount Count of measurements represented by the average. Defaults to 1. Should be >=1.
            * @param {number} min The smallest measurement in the sample. Defaults to the average. Should be >= 0.
            * @param {number} max The largest measurement in the sample. Defaults to the average. Should be >= 0.
            */
            AmpInsightsService.prototype.trackEvent = function (name, properties, measurements) {
                this.appInsights.trackEvent(name, properties, measurements);
            };
            /**
            * Logs that a page or similar container was displayed to the user.
            * @param {string} name A string that identifies the metric. In the portal, you can select metrics for display by name.
            * @param {number} average Either a single measurement, or the average of several measurements. Should be >=0 to be correctly displayed.
            * @param {number} sampleCount Count of measurements represented by the average. Defaults to 1. Should be >=1.
            * @param {number} min The smallest measurement in the sample. Defaults to the average. Should be >= 0.
            * @param {number} max The largest measurement in the sample. Defaults to the average. Should be >= 0.
            */
            AmpInsightsService.prototype.trackMetric = function (name, average, sampleCount, min, max) {
                this.appInsights.trackMetric(name, average, sampleCount, min, max);
            };
            /**
            * Logs that a page or similar container was displayed to the user.
            * @param {Error} exception An Error from a catch clause.
            * @param {string} handledAt Defaults to "unhandled".
            * @param {{[string]:string}} properties Map of string to string: Additional data used to filter pages in the portal. Defaults to empty.
            * @param {{[string]:number}} measurements Map of string to number: Metrics associated with this page, displayed in Metrics Explorer on the portal. Defaults to empty.
            */
            AmpInsightsService.prototype.trackException = function (exception, handledAt, properties, measurements) {
                this.appInsights.trackException(exception, handledAt, properties, measurements);
            };
            /**
            * Log a diagnostic event such as entering or leaving a method.
            * @param {string} message Diagnostic data. Can be much longer than a name.
            * @param {{[string]:string}} properties Map of string to string: Additional data used to filter pages in the portal. Defaults to empty.
            * @param {{[string]:number}} measurements Map of string to number: Metrics associated with this page, displayed in Metrics Explorer on the portal. Defaults to empty.
            */
            AmpInsightsService.prototype.trackTrace = function (message, properties, measurements) {
                this.appInsights.trackTrace(message, properties, measurements);
            };
            /**
            * Immediately send all queued telemetry. Synchronous.
            */
            AmpInsightsService.prototype.flush = function () {
                this.appInsights.flush();
            };
            /**
            * Set the authenticated user id and the account id in this session. Use this when you have identified a specific signed-in user. Parameters must not contain spaces or ,;=|
            * @param {string} authenticatedUserId An id that uniquely identifies a user of your app. No spaces, comma, semicolon, equals or vertical bar.
            * @param {string} accountId An optional account id, if your app groups users into accounts. No spaces, comma, semicolon, equals or vertical bar.
            */
            AmpInsightsService.prototype.setAuthenticatedUserContext = function (authenticatedUserId, accountId) {
                this.appInsights.setAuthenticatedUserContext(authenticatedUserId, accountId);
            };
            /**
            * Clears the authenticated user id and the account id from the user context, and clears the associated cookie.
            */
            AmpInsightsService.prototype.clearAuthenticatedUserContext = function () {
                this.appInsights.clearAuthenticatedUserContext();
            };
            AmpInsightsService.IID = "AmpInsightsService";
            return AmpInsightsService;
        }());
        Services.AmpInsightsService = AmpInsightsService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var AmpKibanaConfigType = (function () {
        function AmpKibanaConfigType() {
        }
        AmpKibanaConfigType.dashboard = "dashboard";
        AmpKibanaConfigType.search = "search";
        AmpKibanaConfigType.visualization = "visualization";
        return AmpKibanaConfigType;
    }());
    AmpCoreApi.AmpKibanaConfigType = AmpKibanaConfigType;
    var Services;
    (function (Services) {
        var AmpKibanaConfigService = (function () {
            function AmpKibanaConfigService(httpService) {
                this._routePrefix = "/api/kibanaconfigs";
                this._httpService = httpService;
            }
            AmpKibanaConfigService.prototype.listKibanaConfigs = function () {
                return this._httpService.listResources(this._routePrefix);
            };
            AmpKibanaConfigService.prototype.getKibanaConfig = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpKibanaConfigService.prototype.createKibanaConfig = function (kibanaConfig) {
                return this._httpService.createResource(this._routePrefix, kibanaConfig);
            };
            AmpKibanaConfigService.prototype.updateKibanaConfig = function (kibanaConfig) {
                return this._httpService.updateResource(this._routePrefix + "/" + kibanaConfig.id, kibanaConfig);
            };
            AmpKibanaConfigService.prototype.deleteKibanaConfig = function (id) {
                return this._httpService.deleteResource(this._routePrefix + "/" + id);
            };
            //#region Extension Methods
            AmpKibanaConfigService.prototype.getKibanaConfigByElasticIdentity = function (elasticIdentity) {
                var uri = Services.AmpHttpService.makeQueryString(this._routePrefix, { elasticIdentity: elasticIdentity });
                return this._httpService.getResource(uri);
            };
            AmpKibanaConfigService.prototype.listKibanaConfigByBundle = function (bundleId) {
                var uri = Services.AmpHttpService.makeQueryString(this._routePrefix, { bundleId: bundleId });
                return this._httpService.listResources(uri);
            };
            AmpKibanaConfigService.IID = "AmpKibanaConfigService";
            AmpKibanaConfigService.$inject = ["AmpHttpService"];
            return AmpKibanaConfigService;
        }());
        Services.AmpKibanaConfigService = AmpKibanaConfigService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpPercolatorService = (function () {
            function AmpPercolatorService(httpService) {
                this._routePrefix = "/api/percolators";
                this._httpService = httpService;
            }
            AmpPercolatorService.prototype.listPercolators = function () {
                return this._httpService.listResources(this._routePrefix);
            };
            AmpPercolatorService.prototype.getPercolator = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpPercolatorService.prototype.createPercolator = function (percolator) {
                return this._httpService.createResource(this._routePrefix, percolator);
            };
            AmpPercolatorService.prototype.updatePercolator = function (percolator, comment) {
                return this._httpService.updateResource(this._routePrefix + "/" + percolator.id + (comment ? "?comment=" + comment : ""), percolator);
            };
            AmpPercolatorService.prototype.deletePercolator = function (id) {
                return this._httpService.deleteResource(this._routePrefix + "/" + id);
            };
            AmpPercolatorService.prototype.listPercolatorsByBundle = function (bundleId) {
                var uri = Services.AmpHttpService.makeQueryString(this._routePrefix, { bundleId: bundleId });
                return this._httpService.listResources(uri);
            };
            AmpPercolatorService.IID = "AmpPercolatorService";
            AmpPercolatorService.$inject = [Services.AmpHttpService.IID];
            return AmpPercolatorService;
        }());
        Services.AmpPercolatorService = AmpPercolatorService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpPingTelemetryService = (function () {
            function AmpPingTelemetryService(httpService, $q) {
                this._routePrefix = "/api/telemetry/ping";
                this._httpService = httpService;
                this._qService = $q;
            }
            AmpPingTelemetryService.prototype.listPingTelemetries = function (rdpTelemetryId) {
                return this._httpService.listResources(this._routePrefix + "/" + rdpTelemetryId);
            };
            AmpPingTelemetryService.prototype.createPingTelemetry = function (ping) {
                return this._httpService.createResource(this._routePrefix, ping);
            };
            AmpPingTelemetryService.IID = "AmpPingTelemetryService";
            AmpPingTelemetryService.$inject = ["AmpHttpService", "$q"];
            return AmpPingTelemetryService;
        }());
        Services.AmpPingTelemetryService = AmpPingTelemetryService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    (function (ParameterType) {
        ParameterType[ParameterType["String"] = 0] = "String";
        ParameterType[ParameterType["Integer"] = 1] = "Integer";
        ParameterType[ParameterType["Float"] = 2] = "Float";
        ParameterType[ParameterType["Boolean"] = 3] = "Boolean";
        ParameterType[ParameterType["DateTime"] = 4] = "DateTime";
        ParameterType[ParameterType["Guid"] = 5] = "Guid";
        ParameterType[ParameterType["TimeSpan"] = 6] = "TimeSpan";
        ParameterType[ParameterType["StringArray"] = 7] = "StringArray";
    })(AmpCoreApi.ParameterType || (AmpCoreApi.ParameterType = {}));
    var ParameterType = AmpCoreApi.ParameterType;
    (function (PropertyType) {
        PropertyType[PropertyType["Unknown"] = 0] = "Unknown";
        PropertyType[PropertyType["String"] = 1] = "String";
        PropertyType[PropertyType["Number"] = 2] = "Number";
        PropertyType[PropertyType["Date"] = 3] = "Date";
        PropertyType[PropertyType["Boolean"] = 4] = "Boolean";
        PropertyType[PropertyType["Binary"] = 5] = "Binary";
        PropertyType[PropertyType["Float"] = 6] = "Float";
        PropertyType[PropertyType["Double"] = 7] = "Double";
        PropertyType[PropertyType["Byte"] = 8] = "Byte";
        PropertyType[PropertyType["Short"] = 9] = "Short";
        PropertyType[PropertyType["Integer"] = 10] = "Integer";
        PropertyType[PropertyType["Long"] = 11] = "Long";
    })(AmpCoreApi.PropertyType || (AmpCoreApi.PropertyType = {}));
    var PropertyType = AmpCoreApi.PropertyType;
    var Services;
    (function (Services) {
        var AmpProbeService = (function () {
            function AmpProbeService(httpService) {
                this._routePrefix = "/api/probes";
                this._httpService = httpService;
            }
            AmpProbeService.prototype.listProbes = function () {
                return this._httpService.listResources(this._routePrefix);
            };
            AmpProbeService.prototype.getProbe = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpProbeService.prototype.createProbe = function (probe) {
                return this._httpService.createResource(this._routePrefix, probe);
            };
            AmpProbeService.prototype.updateProbe = function (probe, comment) {
                return this._httpService.updateResource(this._routePrefix + "/" + probe.id + (comment ? "?comment=" + comment : ""), probe);
            };
            AmpProbeService.prototype.deleteProbe = function (id) {
                return this._httpService.deleteResource(this._routePrefix + "/" + id);
            };
            AmpProbeService.prototype.listProbesByBundle = function (bundleId) {
                var uri = Services.AmpHttpService.makeQueryString(this._routePrefix, { bundleId: bundleId });
                return this._httpService.listResources(uri);
            };
            AmpProbeService.prototype.getProbeByName = function (probeName) {
                var uri = Services.AmpHttpService.makeQueryString(this._routePrefix, { probeName: probeName });
                return this._httpService.getResource(uri);
            };
            AmpProbeService.IID = "AmpProbeService";
            AmpProbeService.$inject = ["AmpHttpService"];
            return AmpProbeService;
        }());
        Services.AmpProbeService = AmpProbeService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpRdpLogService = (function () {
            function AmpRdpLogService(httpService) {
                this._routePrefix = "/api/logs/rdp";
                this._httpService = httpService;
            }
            AmpRdpLogService.prototype.getRdpLog = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpRdpLogService.prototype.listRdpLogs = function (from, to, user, accountId, siteId, targetId) {
                var uri = Services.AmpHttpService.makeQueryString(this._routePrefix, {
                    from: from,
                    to: to,
                    user: user,
                    accountId: accountId,
                    siteId: siteId,
                    targetId: targetId
                });
                return this._httpService.listResources(uri);
            };
            AmpRdpLogService.IID = "AmpRdpLogService";
            AmpRdpLogService.$inject = ["AmpHttpService"];
            return AmpRdpLogService;
        }());
        Services.AmpRdpLogService = AmpRdpLogService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpRdpSessionService = (function () {
            function AmpRdpSessionService(httpService) {
                this._routePrefix = "/api/rdpsessions";
                this._httpService = httpService;
            }
            AmpRdpSessionService.prototype.listRdpSessions = function (targetId) {
                return this._httpService.listResources(this._routePrefix + "?targetId=" + targetId);
            };
            AmpRdpSessionService.prototype.listRdpSessionsBySite = function (siteId) {
                return this._httpService.listResources(this._routePrefix + "?siteId=" + siteId);
            };
            AmpRdpSessionService.prototype.deleteRdpSession = function (id) {
                return this._httpService.deleteResource(this._routePrefix + "/" + id);
            };
            AmpRdpSessionService.IID = "AmpRdpSessionService";
            AmpRdpSessionService.$inject = ["AmpHttpService"];
            return AmpRdpSessionService;
        }());
        Services.AmpRdpSessionService = AmpRdpSessionService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpRdpTelemetryService = (function () {
            function AmpRdpTelemetryService(httpService, $q) {
                this._routePrefix = "/api/telemetry/rdp";
                this._httpService = httpService;
                this._qService = $q;
            }
            AmpRdpTelemetryService.prototype.getRdpTelemetry = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpRdpTelemetryService.prototype.getRdpTelemetryByLogId = function (logId) {
                return this._httpService.getResource(this._routePrefix + "/log/" + logId);
            };
            AmpRdpTelemetryService.prototype.listRdpTelemetries = function (from, to, user, accountId, siteId, targetId) {
                var uri = Services.AmpHttpService.makeQueryString(this._routePrefix, {
                    from: from,
                    to: to,
                    user: user,
                    accountId: accountId,
                    siteId: siteId,
                    targetId: targetId
                });
                return this._httpService.listResources(uri);
            };
            AmpRdpTelemetryService.prototype.createRdpTelemetry = function (telemetry) {
                return this._httpService.createResource(this._routePrefix, telemetry);
            };
            AmpRdpTelemetryService.prototype.updateRdpTelemetry = function (telemetry) {
                return this._httpService.updateResource(this._routePrefix + "/" + telemetry.id + "/update", telemetry);
            };
            AmpRdpTelemetryService.prototype.endRdpTelemetry = function (telemetry) {
                return this._httpService.updateResource(this._routePrefix + "/" + telemetry.id + "/end", telemetry);
            };
            AmpRdpTelemetryService.IID = "AmpRdpTelemetryService";
            AmpRdpTelemetryService.$inject = ["AmpHttpService", "$q"];
            return AmpRdpTelemetryService;
        }());
        Services.AmpRdpTelemetryService = AmpRdpTelemetryService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpRedisCacheService = (function () {
            function AmpRedisCacheService(httpService) {
                this._routePrefix = "/api/redis";
                this._httpService = httpService;
            }
            AmpRedisCacheService.prototype.clearCache = function () {
                return this._httpService.deleteResource(this._routePrefix);
            };
            AmpRedisCacheService.IID = "AmpRedisCacheService";
            AmpRedisCacheService.$inject = ["AmpHttpService"];
            return AmpRedisCacheService;
        }());
        Services.AmpRedisCacheService = AmpRedisCacheService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpScriptExecutionLogService = (function () {
            function AmpScriptExecutionLogService(httpService) {
                this._routePrefix = "/api/logs/psrunner";
                this._httpService = httpService;
            }
            AmpScriptExecutionLogService.prototype.getScriptExecutionLog = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpScriptExecutionLogService.prototype.listScriptExecutionLogs = function (from, to, user, accountId, siteId) {
                var uri = Services.AmpHttpService.makeQueryString(this._routePrefix, {
                    from: from,
                    to: to,
                    user: user,
                    accountId: accountId,
                    siteId: siteId
                });
                return this._httpService.listResources(uri);
            };
            AmpScriptExecutionLogService.IID = "AmpScriptExecutionLogService";
            AmpScriptExecutionLogService.$inject = ["AmpHttpService"];
            return AmpScriptExecutionLogService;
        }());
        Services.AmpScriptExecutionLogService = AmpScriptExecutionLogService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpScriptService = (function () {
            function AmpScriptService(httpService) {
                this._routePrefix = "/api/scripts";
                this._httpService = httpService;
            }
            AmpScriptService.prototype.getScript = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpScriptService.prototype.createScript = function (script) {
                return this._httpService.createResource(this._routePrefix, script);
            };
            AmpScriptService.prototype.updateScript = function (script) {
                return this._httpService.updateResource(this._routePrefix + "/" + script.id, script);
            };
            AmpScriptService.prototype.deleteScript = function (id) {
                return this._httpService.deleteResource(this._routePrefix + "/" + id);
            };
            AmpScriptService.prototype.listScripts = function () {
                return this._httpService.listResources(this._routePrefix);
            };
            AmpScriptService.prototype.parseScript = function (script) {
                return this._httpService.putResourceWithResponse(this._routePrefix + "/parse", script);
            };
            AmpScriptService.IID = "AmpScriptService";
            AmpScriptService.$inject = ["AmpHttpService"];
            return AmpScriptService;
        }());
        Services.AmpScriptService = AmpScriptService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpSecurityLogService = (function () {
            function AmpSecurityLogService(httpService) {
                this._routePrefix = "/api/logs/security";
                this._httpService = httpService;
            }
            AmpSecurityLogService.prototype.getSecurityLog = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpSecurityLogService.prototype.listSecurityLogs = function () {
                return this._httpService.listResources(this._routePrefix);
            };
            AmpSecurityLogService.IID = "AmpSecurityLogService";
            AmpSecurityLogService.$inject = ["AmpHttpService"];
            return AmpSecurityLogService;
        }());
        Services.AmpSecurityLogService = AmpSecurityLogService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpSiteIssueService = (function () {
            function AmpSiteIssueService($rsp) {
                this.routePrefix = "monitoring/api/v1/issue";
                this.$rsp = $rsp;
            }
            AmpSiteIssueService.prototype.list = function (siteId) {
                return this.$rsp.listResources(siteId, this.routePrefix);
            };
            AmpSiteIssueService.IID = "AmpSiteIssueService";
            AmpSiteIssueService.$inject = ["AmpSiteProxyService"];
            return AmpSiteIssueService;
        }());
        Services.AmpSiteIssueService = AmpSiteIssueService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpSiteKibanaConfigService = (function () {
            function AmpSiteKibanaConfigService(httpService) {
                this._routePrefix = "/api/sites";
                this._httpService = httpService;
            }
            AmpSiteKibanaConfigService.prototype.listDashboards = function (siteId) {
                return this._httpService.listResources(this._routePrefix + "/" + siteId + "/kibana");
            };
            AmpSiteKibanaConfigService.prototype.exportDashboards = function (siteId, siteDashboardIdentities) {
                return this._httpService.postResourceDifferentOutput(this._routePrefix + "/" + siteId + "/kibana/export", siteDashboardIdentities);
            };
            AmpSiteKibanaConfigService.prototype.importDashboards = function (siteId, coreDashboardIdentities) {
                return this._httpService.postResourceDifferentOutput(this._routePrefix + "/" + siteId + "/kibana/import", coreDashboardIdentities);
            };
            AmpSiteKibanaConfigService.IID = "AmpSiteKibanaConfigService";
            AmpSiteKibanaConfigService.$inject = ["AmpHttpService"];
            return AmpSiteKibanaConfigService;
        }());
        Services.AmpSiteKibanaConfigService = AmpSiteKibanaConfigService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpSitePercolatorService = (function () {
            function AmpSitePercolatorService($rsp) {
                this.routePrefix = "monitoring/api/v1/percolator";
                this.$rsp = $rsp;
            }
            AmpSitePercolatorService.prototype.test = function (siteId, c) {
                return this.$rsp.postResourceDifferentOutput(siteId, this.routeToId("test"), c);
            };
            AmpSitePercolatorService.prototype.render = function (siteId, c) {
                return this.$rsp.postResourceDifferentOutput(siteId, this.routePrefix + "/render", c);
            };
            AmpSitePercolatorService.prototype.routeToId = function (id) {
                return this.routePrefix + (!!id ? "/" + id : '');
            };
            AmpSitePercolatorService.IID = "AmpSitePercolatorService";
            AmpSitePercolatorService.$inject = ["AmpSiteProxyService"];
            return AmpSitePercolatorService;
        }());
        Services.AmpSitePercolatorService = AmpSitePercolatorService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpSiteProviderService = (function () {
            function AmpSiteProviderService($q, $rsp) {
                this.routePrefix = "monitoring/api/v1/provider";
                this.$q = $q;
                this.$rsp = $rsp;
            }
            AmpSiteProviderService.prototype.list = function (siteId) {
                return this.$rsp.listResources(siteId, this.routePrefix);
            };
            AmpSiteProviderService.prototype.query = function (siteId, provider, bundle, request) {
                var uri = Services.AmpHttpService.makeQueryString(this.routeToId("query"), {
                    provider: provider,
                    bundle: bundle
                });
                return this.$rsp.postResourceDifferentOutput(siteId, uri, request);
            };
            AmpSiteProviderService.prototype.execute = function (siteId, request) {
                return this.$rsp.postResourceDifferentOutput(siteId, this.routeToId("execute"), request);
            };
            AmpSiteProviderService.prototype.get = function (siteId, id) {
                return this.$rsp.getResource(siteId, this.routeToId(id));
            };
            AmpSiteProviderService.prototype.routeToId = function (id) { return this.routePrefix + "/" + id; };
            AmpSiteProviderService.IID = "AmpSiteProviderService";
            AmpSiteProviderService.$inject = ["$q", "AmpSiteProxyService"];
            return AmpSiteProviderService;
        }());
        Services.AmpSiteProviderService = AmpSiteProviderService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        (function (ProxyHttpMethod) {
            ProxyHttpMethod[ProxyHttpMethod["badrequest"] = 0] = "badrequest";
            ProxyHttpMethod[ProxyHttpMethod["get"] = 1] = "get";
            ProxyHttpMethod[ProxyHttpMethod["post"] = 2] = "post";
            ProxyHttpMethod[ProxyHttpMethod["put"] = 3] = "put";
            ProxyHttpMethod[ProxyHttpMethod["delete"] = 4] = "delete";
        })(Services.ProxyHttpMethod || (Services.ProxyHttpMethod = {}));
        var ProxyHttpMethod = Services.ProxyHttpMethod;
        var AmpSiteProxyService = (function () {
            function AmpSiteProxyService($q, httpService) {
                this._routePrefix = "/api/sites";
                this._q = $q;
                this._httpService = httpService;
            }
            AmpSiteProxyService.prototype.listResources = function (siteId, uri) {
                var siteMsg = {
                    method: ProxyHttpMethod.get,
                    uri: uri
                };
                var deferred = this._q.defer();
                this.postSiteProxy(siteId, siteMsg)
                    .then(function (data) {
                    deferred.resolve(data);
                }, function (cb) {
                    deferred.reject(cb);
                });
                return deferred.promise;
            };
            AmpSiteProxyService.prototype.getResource = function (siteId, uri) {
                var siteMsg = {
                    method: ProxyHttpMethod.get,
                    uri: uri
                };
                var deferred = this._q.defer();
                this.postSiteProxy(siteId, siteMsg)
                    .then(function (data) {
                    deferred.resolve(data);
                }, function (cb) {
                    deferred.reject(cb);
                });
                return deferred.promise;
            };
            AmpSiteProxyService.prototype.postResources = function (siteId, uri, data) {
                var siteMsg = {
                    method: ProxyHttpMethod.post,
                    uri: uri,
                    data: data
                };
                var deferred = this._q.defer();
                this.postSiteProxy(siteId, siteMsg)
                    .then(function (ret) {
                    deferred.resolve(ret);
                }, function (cb) {
                    deferred.reject(cb);
                });
                return deferred.promise;
            };
            AmpSiteProxyService.prototype.postResourceDifferentOutput = function (siteId, uri, data) {
                var siteMsg = {
                    method: ProxyHttpMethod.post,
                    uri: uri,
                    data: data
                };
                var deferred = this._q.defer();
                this.postSiteProxy(siteId, siteMsg)
                    .then(function (ret) {
                    deferred.resolve(ret);
                }, function (cb) {
                    deferred.reject(cb);
                });
                return deferred.promise;
            };
            AmpSiteProxyService.prototype.postResourceNoBody = function (siteId, uri) {
                var siteMsg = {
                    method: ProxyHttpMethod.post,
                    uri: uri
                };
                var deferred = this._q.defer();
                this.postSiteProxy(siteId, siteMsg)
                    .then(function () {
                    deferred.resolve();
                }, function (cb) {
                    deferred.reject(cb);
                });
                return deferred.promise;
            };
            AmpSiteProxyService.prototype.putResources = function (siteId, uri, data) {
                var siteMsg = {
                    method: ProxyHttpMethod.put,
                    uri: uri,
                    data: data
                };
                var deferred = this._q.defer();
                this.postSiteProxy(siteId, siteMsg)
                    .then(function () {
                    deferred.resolve();
                }, function (cb) {
                    deferred.reject(cb);
                });
                return deferred.promise;
            };
            AmpSiteProxyService.prototype.deleteResource = function (siteId, uri) {
                var siteMsg = {
                    method: ProxyHttpMethod.delete,
                    uri: uri
                };
                var deferred = this._q.defer();
                this.postSiteProxy(siteId, siteMsg)
                    .then(function () {
                    deferred.resolve();
                }, function (cb) {
                    deferred.reject(cb);
                });
                return deferred.promise;
            };
            AmpSiteProxyService.prototype.postSiteProxy = function (siteId, siteMessage) {
                var deferred = this._q.defer();
                this._httpService.postResource(this._routePrefix + "/" + siteId + "/proxy", siteMessage)
                    .then(function (response) {
                    deferred.resolve(response);
                }, function (error) {
                    deferred.reject(error);
                });
                return deferred.promise;
            };
            AmpSiteProxyService.IID = "AmpSiteProxyService";
            AmpSiteProxyService.$inject = ["$q", "AmpHttpService"];
            return AmpSiteProxyService;
        }());
        Services.AmpSiteProxyService = AmpSiteProxyService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpSiteResponderService = (function () {
            function AmpSiteResponderService($q, $rsp) {
                this.routePrefix = "monitoring/api/v1/responder";
                this.$q = $q;
                this.$rsp = $rsp;
            }
            AmpSiteResponderService.prototype.list = function (siteId) {
                return this.$rsp.listResources(siteId, this.routePrefix);
            };
            AmpSiteResponderService.IID = "AmpSiteResponderService";
            AmpSiteResponderService.$inject = ["$q", "AmpSiteProxyService"];
            return AmpSiteResponderService;
        }());
        Services.AmpSiteResponderService = AmpSiteResponderService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpSiteRuleService = (function () {
            function AmpSiteRuleService(httpService) {
                this._routePrefix = "/api/siterules";
                this._httpService = httpService;
            }
            AmpSiteRuleService.prototype.listSiteRules = function () {
                return this._httpService.listResources(this._routePrefix);
            };
            AmpSiteRuleService.prototype.getSiteRule = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpSiteRuleService.prototype.createSiteRule = function (siteRule) {
                return this._httpService.createResource(this._routePrefix, siteRule);
            };
            AmpSiteRuleService.prototype.updateSiteRule = function (siteRule) {
                return this._httpService.updateResource(this._routePrefix + "/" + siteRule.id, siteRule);
            };
            AmpSiteRuleService.prototype.deleteSiteRule = function (id) {
                return this._httpService.deleteResource(this._routePrefix + "/" + id);
            };
            AmpSiteRuleService.prototype.listSiteRulesBySite = function (siteId) {
                return this._httpService.listResources(this._routePrefix + "?siteId=" + siteId);
            };
            AmpSiteRuleService.prototype.listSiteRulesByCoreSg = function (coreSgId) {
                return this._httpService.listResources(this._routePrefix + "?coreSgId=" + coreSgId);
            };
            AmpSiteRuleService.prototype.listSiteRulesByAccount = function (accountId) {
                return this._httpService.listResources(this._routePrefix + "?accountId=" + accountId);
            };
            AmpSiteRuleService.IID = "AmpSiteRuleService";
            AmpSiteRuleService.$inject = ["AmpHttpService"];
            return AmpSiteRuleService;
        }());
        Services.AmpSiteRuleService = AmpSiteRuleService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpSiteScheduleService = (function () {
            function AmpSiteScheduleService($rsp) {
                this.routePrefix = "monitoring/api/v1/schedule";
                this.$rsp = $rsp;
            }
            AmpSiteScheduleService.prototype.list = function (siteId) {
                return this.$rsp.listResources(siteId, this.routePrefix);
            };
            AmpSiteScheduleService.prototype.store = function (siteId, schedule, id) {
                return this.$rsp.putResources(siteId, this.routeToId(id), schedule);
            };
            AmpSiteScheduleService.prototype.storeMultiple = function (siteId, schedules) {
                return this.$rsp.putResources(siteId, this.routePrefix, schedules);
            };
            AmpSiteScheduleService.prototype.remove = function (siteId, id) {
                return this.$rsp.deleteResource(siteId, this.routeToId(id));
            };
            AmpSiteScheduleService.prototype.removeMultiple = function (siteId, ids) {
                return this.$rsp.putResources(siteId, this.routePrefix + "/deletemultiple", ids);
            };
            AmpSiteScheduleService.prototype.get = function (siteId, id) {
                return this.$rsp.getResource(siteId, this.routeToId(id));
            };
            AmpSiteScheduleService.prototype.getByTarget = function (siteId, targetId) {
                return this.$rsp.listResources(siteId, this.routeToId("target/" + targetId));
            };
            AmpSiteScheduleService.prototype.routeToId = function (id) {
                return this.routePrefix + (!!id ? "/" + id : '');
            };
            AmpSiteScheduleService.IID = "AmpSiteScheduleService";
            AmpSiteScheduleService.$inject = ["AmpSiteProxyService"];
            return AmpSiteScheduleService;
        }());
        Services.AmpSiteScheduleService = AmpSiteScheduleService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    (function (RdpConnectors) {
        RdpConnectors[RdpConnectors["hcm"] = 0] = "hcm";
        RdpConnectors[RdpConnectors["webService"] = 1] = "webService";
    })(AmpCoreApi.RdpConnectors || (AmpCoreApi.RdpConnectors = {}));
    var RdpConnectors = AmpCoreApi.RdpConnectors;
    var AmpRdpEncodingStatus = (function () {
        function AmpRdpEncodingStatus() {
        }
        AmpRdpEncodingStatus.NotStarted = "NotStarted";
        AmpRdpEncodingStatus.Encoding = "Encoding";
        AmpRdpEncodingStatus.Encoded = "Encoded";
        AmpRdpEncodingStatus.Canceled = "Canceled";
        AmpRdpEncodingStatus.Failed = "Failed";
        return AmpRdpEncodingStatus;
    }());
    AmpCoreApi.AmpRdpEncodingStatus = AmpRdpEncodingStatus;
    var Services;
    (function (Services) {
        var AmpSiteService = (function () {
            function AmpSiteService(httpService, $rsp) {
                this._coreRoutePrefix = "/api/sites";
                this._siteRoutePrefix = "remoteaccess/api/v1/rdp/video";
                this._httpService = httpService;
                this.$rsp = $rsp;
            }
            AmpSiteService.prototype.listSites = function () {
                return this._httpService.listResources(this._coreRoutePrefix);
            };
            AmpSiteService.prototype.getSite = function (id) {
                return this._httpService.getResource(this._coreRoutePrefix + "/" + id);
            };
            AmpSiteService.prototype.createSite = function (site) {
                return this._httpService.createResource(this._coreRoutePrefix, site);
            };
            AmpSiteService.prototype.updateSite = function (site) {
                return this._httpService.updateResource(this._coreRoutePrefix + "/" + site.id, site);
            };
            AmpSiteService.prototype.deleteSite = function (id) {
                return this._httpService.deleteResource(this._coreRoutePrefix + "/" + id);
            };
            AmpSiteService.prototype.listSitesByAccount = function (accountId) {
                return this._httpService.listResources(this._coreRoutePrefix + "?accountId=" + accountId);
            };
            AmpSiteService.prototype.checkSiteRdpVideos = function (siteId, connectionIds) {
                return this._httpService.postResource(this._coreRoutePrefix + "/" + siteId + "/rdpvideos", connectionIds);
            };
            AmpSiteService.prototype.getSiteRdpVideoUrl = function (id, connectionId) {
                var baseUrl = this._httpService.getBaseAddress();
                return baseUrl + this._coreRoutePrefix + "/" + id + "/rdpvideos/" + connectionId;
            };
            AmpSiteService.prototype.getSiteRdpEncodingLogs = function (siteId, connectionIds) {
                return this._httpService.postResourceDifferentOutput(this._coreRoutePrefix + "/" + siteId + "/rdpencodings", connectionIds);
            };
            AmpSiteService.prototype.getSiteRdpEncodingLog = function (siteId, connectionId) {
                return this._httpService.getResource(this._coreRoutePrefix + "/" + siteId + "/rdpencodings/" + connectionId);
            };
            AmpSiteService.prototype.startSiteRdpEnconding = function (siteId, connectionId) {
                return this._httpService.postResourceDifferentOutput(this._coreRoutePrefix + "/" + siteId + "/rdpencodings/" + connectionId + "/encode");
            };
            AmpSiteService.prototype.cancelSiteRdpEnconding = function (siteId, connectionId) {
                return this._httpService.postResourceDifferentOutput(this._coreRoutePrefix + "/" + siteId + "/rdpencodings/" + connectionId + "/cancel");
            };
            AmpSiteService.prototype.getSiteLink = function (siteId) {
                return this._httpService.getResource(this._coreRoutePrefix + "/" + siteId + "/sitelink");
            };
            AmpSiteService.prototype.getSiteLinkPrefetch = function (siteId) {
                return this._httpService.getResource(this._coreRoutePrefix + "/" + siteId + "/sitelink/prefetch");
            };
            AmpSiteService.prototype.createSiteLink = function (siteId) {
                return this._httpService.createResource(this._coreRoutePrefix + "/" + siteId + "/sitelink", null);
            };
            AmpSiteService.prototype.deleteSiteLink = function (siteId) {
                return this._httpService.deleteResource(this._coreRoutePrefix + "/" + siteId + "/sitelink");
            };
            AmpSiteService.prototype.getSiteLinkConnectionString = function (siteId) {
                return this._httpService.getResource(this._coreRoutePrefix + "/" + siteId + "/sitelink/connection-string");
            };
            AmpSiteService.prototype.getSiteIntegrationKey = function (siteId) {
                return this._httpService.getResource(this._coreRoutePrefix + "/" + siteId + "/integration-key");
            };
            AmpSiteService.prototype.createSiteIntegrationKey = function (siteId) {
                return this._httpService.createResource(this._coreRoutePrefix + "/" + siteId + "/integration-key", null);
            };
            AmpSiteService.prototype.deleteSiteIntegrationKey = function (siteId) {
                return this._httpService.deleteResource(this._coreRoutePrefix + "/" + siteId + "/integration-key");
            };
            AmpSiteService.prototype.uploadSiteInstaller = function (siteId, packageName) {
                return this._httpService.createResource(this._coreRoutePrefix + "/" + siteId + "/amp-installer/upload/" + packageName, null);
            };
            AmpSiteService.prototype.regenerateSiteInstallers = function (siteId) {
                return this._httpService.postResource(this._coreRoutePrefix + "/" + siteId + "/amp-installer/regenerate", null);
            };
            AmpSiteService.prototype.createSiteInstaller = function (siteId, packageName) {
                return this._httpService.createResource(this._coreRoutePrefix + "/" + siteId + "/amp-installer" + "/" + packageName, null);
            };
            AmpSiteService.prototype.installMonitoring = function (siteId) {
                return this._httpService.postResource(this._coreRoutePrefix + "/" + siteId + "/install-monitoring", null);
            };
            AmpSiteService.prototype.installProductionMonitoring = function (siteId) {
                return this._httpService.postResource(this._coreRoutePrefix + "/" + siteId + "/install-monitoring/production", null);
            };
            AmpSiteService.prototype.installMonitoringBundles = function (siteId, bundleIds) {
                var uri = this._coreRoutePrefix + "/" + siteId + "/install-monitoring";
                return this._httpService.postResource(uri, bundleIds);
            };
            AmpSiteService.prototype.installProductionMonitoringBundles = function (siteId, bundleIds) {
                var uri = this._coreRoutePrefix + "/" + siteId + "/install-monitoring/production";
                return this._httpService.postResource(uri, bundleIds);
            };
            AmpSiteService.IID = "AmpSiteService";
            AmpSiteService.$inject = ["AmpHttpService", "AmpSiteProxyService"];
            return AmpSiteService;
        }());
        Services.AmpSiteService = AmpSiteService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpSiteTargetService = (function () {
            function AmpSiteTargetService($rsp) {
                this.routePrefix = "monitoring/api/v1/target";
                this.$rsp = $rsp;
            }
            AmpSiteTargetService.prototype.list = function (siteId) {
                return this.$rsp.listResources(siteId, this.routePrefix);
            };
            AmpSiteTargetService.prototype.store = function (siteId, target, id) {
                return this.$rsp.putResources(siteId, this.routeToId(id), target);
            };
            AmpSiteTargetService.prototype.storeMultiple = function (siteId, targets) {
                return this.$rsp.putResources(siteId, this.routePrefix, targets);
            };
            AmpSiteTargetService.prototype.remove = function (siteId, id) {
                return this.$rsp.deleteResource(siteId, this.routeToId(id));
            };
            AmpSiteTargetService.prototype.removeMultiple = function (siteId, ids) {
                return this.$rsp.putResources(siteId, this.routePrefix + "/deletemultiple", ids);
            };
            AmpSiteTargetService.prototype.get = function (siteId, id) {
                return this.$rsp.getResource(siteId, this.routeToId(id));
            };
            AmpSiteTargetService.prototype.reallocate = function (siteId, node) {
                var baseUri = this.routeToId("reallocate");
                var uri = node ? Services.AmpHttpService.makeQueryString(baseUri, { node: node }) : baseUri;
                return this.$rsp.postResourceNoBody(siteId, uri);
            };
            AmpSiteTargetService.prototype.routeToId = function (id) {
                return this.routePrefix + (!!id ? "/" + id : '');
            };
            AmpSiteTargetService.IID = "AmpSiteTargetService";
            AmpSiteTargetService.$inject = ["AmpSiteProxyService"];
            return AmpSiteTargetService;
        }());
        Services.AmpSiteTargetService = AmpSiteTargetService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpSiteDeploymentService = (function () {
            function AmpSiteDeploymentService($rsp) {
                this.routePrefix = "monitoring/api/v1/deployment";
                this.$rsp = $rsp;
            }
            AmpSiteDeploymentService.prototype.getBundles = function (siteId) {
                return this.$rsp.getResource(siteId, this.routePrefix);
            };
            AmpSiteDeploymentService.prototype.getProductionBundles = function (siteId) {
                return this.$rsp.getResource(siteId, this.routePrefix + "/production");
            };
            AmpSiteDeploymentService.IID = "AmpSiteDeploymentService";
            AmpSiteDeploymentService.$inject = ["AmpSiteProxyService"];
            return AmpSiteDeploymentService;
        }());
        Services.AmpSiteDeploymentService = AmpSiteDeploymentService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpSiteTriggerService = (function () {
            function AmpSiteTriggerService($rsp) {
                this.routePrefix = "monitoring/api/v1/trigger";
                this.$rsp = $rsp;
            }
            AmpSiteTriggerService.prototype.test = function (siteId, c) {
                return this.$rsp.postResourceDifferentOutput(siteId, this.routeToId("test"), c);
            };
            AmpSiteTriggerService.prototype.testWithRaw = function (siteId, c) {
                return this.$rsp.postResourceDifferentOutput(siteId, this.routeToId("testwithraw"), c);
            };
            AmpSiteTriggerService.prototype.routeToId = function (id) {
                return this.routePrefix + (!!id ? "/" + id : '');
            };
            AmpSiteTriggerService.IID = "AmpSiteTriggerService";
            AmpSiteTriggerService.$inject = ["AmpSiteProxyService"];
            return AmpSiteTriggerService;
        }());
        Services.AmpSiteTriggerService = AmpSiteTriggerService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpSubscriptionService = (function () {
            function AmpSubscriptionService(httpService) {
                this._routePrefix = "/api/subscriptions";
                this._httpService = httpService;
            }
            AmpSubscriptionService.prototype.listSubscriptions = function () {
                return this._httpService.listResources(this._routePrefix);
            };
            AmpSubscriptionService.prototype.getSubscription = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpSubscriptionService.prototype.createSubscription = function (subscription) {
                return this._httpService.createResource(this._routePrefix, subscription);
            };
            AmpSubscriptionService.prototype.deleteSubscription = function (id) {
                return this._httpService.deleteResource(this._routePrefix + "/" + id);
            };
            AmpSubscriptionService.IID = "AmpSubscriptionService";
            AmpSubscriptionService.$inject = ["AmpHttpService"];
            return AmpSubscriptionService;
        }());
        Services.AmpSubscriptionService = AmpSubscriptionService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var AmpTargetProtocol = (function () {
        function AmpTargetProtocol() {
        }
        AmpTargetProtocol.rdp = "rdp:";
        AmpTargetProtocol.powershell = "powershell:";
        AmpTargetProtocol.ssh = "ssh:";
        AmpTargetProtocol.http = "http:";
        AmpTargetProtocol.https = "https:";
        AmpTargetProtocol.monitoring = "monitoring:";
        return AmpTargetProtocol;
    }());
    AmpCoreApi.AmpTargetProtocol = AmpTargetProtocol;
    var Services;
    (function (Services) {
        var AmpTargetService = (function () {
            function AmpTargetService(httpService) {
                this._routePrefix = "/api/targets";
                this._httpService = httpService;
            }
            AmpTargetService.prototype.listTargets = function (siteId, type) {
                var _this = this;
                var uri = Services.AmpHttpService.makeQueryString(this._routePrefix, {
                    siteId: siteId,
                    type: type
                });
                return this._httpService.listResources(uri).then(function (targets) {
                    for (var i = 0; i < targets.length; i++) {
                        _this.fixupTargetEndpoints(targets[i]);
                    }
                    return targets;
                });
            };
            AmpTargetService.prototype.getTarget = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpTargetService.prototype.fixupTargetEndpoints = function (target) {
                target.targetEndpoints = [];
                for (var i = 0; i < target.endpoints.length; i++) {
                    var ep = target.endpoints[i];
                    target.targetEndpoints.push(this.parseUri(ep));
                }
            };
            AmpTargetService.prototype.getTargetSiteAccount = function (id) {
                var _this = this;
                return this._httpService.getResource(this._routePrefix + "/" + id + "/prefetch")
                    .then(function (tsa) {
                    _this.fixupTargetEndpoints(tsa.target);
                    return tsa;
                });
            };
            AmpTargetService.prototype.getTargetByExternalId = function (siteId, externalId) {
                var _this = this;
                return this._httpService.getResource(this._routePrefix + "?siteId=" + siteId + "&externalId=" + externalId)
                    .then(function (tsa) {
                    _this.fixupTargetEndpoints(tsa.target);
                    return tsa;
                });
            };
            AmpTargetService.prototype.listTargetTypes = function (siteId) {
                var uri = Services.AmpHttpService.makeQueryString(this._routePrefix + "/types", {
                    siteId: siteId
                });
                return this._httpService.listResources(uri);
            };
            AmpTargetService.prototype.getTargetCapability = function (target, protocol) {
                this.fixupTargetEndpoints(target);
                return target.targetEndpoints.some(function (p) { return p.protocol === protocol; });
            };
            AmpTargetService.prototype.parseUri = function (uri) {
                var parser = document.createElement("a");
                parser.href = uri;
                var savedProtocol = parser.protocol;
                // nonstandard protocols cause .hostname, .pathname, etc to not work, so we replace with http and do it then...
                var newUri = uri.replace(savedProtocol, "http:");
                parser.href = newUri;
                var undefined;
                var parsedPort = parseInt(parser.port);
                return {
                    uri: uri,
                    protocol: savedProtocol,
                    host: parser.hostname,
                    port: isNaN(parsedPort) ? undefined : parsedPort,
                    path: parser.pathname,
                    query: parser.search,
                    fragment: parser.hash
                };
            };
            AmpTargetService.IID = "AmpTargetService";
            AmpTargetService.$inject = ["AmpHttpService"];
            return AmpTargetService;
        }());
        Services.AmpTargetService = AmpTargetService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpTenantService = (function () {
            function AmpTenantService(httpService) {
                this._routePrefix = "/api/tenants";
                this._httpService = httpService;
            }
            AmpTenantService.prototype.listTenants = function () {
                return this._httpService.listResources(this._routePrefix);
            };
            AmpTenantService.prototype.getTenant = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpTenantService.prototype.createTenant = function (tenant) {
                return this._httpService.createResource(this._routePrefix, tenant);
            };
            AmpTenantService.prototype.updateTenant = function (tenant) {
                return this._httpService.updateResource(this._routePrefix + "/" + tenant.id, tenant);
            };
            AmpTenantService.prototype.deleteTenant = function (id) {
                return this._httpService.deleteResource(this._routePrefix + "/" + id);
            };
            AmpTenantService.IID = "AmpTenantService";
            AmpTenantService.$inject = ["AmpHttpService"];
            return AmpTenantService;
        }());
        Services.AmpTenantService = AmpTenantService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpTimeZoneService = (function () {
            function AmpTimeZoneService(httpService) {
                this._routePrefix = "/api/utils/timezones";
                this._httpService = httpService;
            }
            AmpTimeZoneService.prototype.listTimeZones = function () {
                return this._httpService.listResources(this._routePrefix);
            };
            AmpTimeZoneService.IID = "AmpTimeZoneService";
            AmpTimeZoneService.$inject = ["AmpHttpService"];
            return AmpTimeZoneService;
        }());
        Services.AmpTimeZoneService = AmpTimeZoneService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpTriggerService = (function () {
            function AmpTriggerService(httpService) {
                this._routePrefix = "/api/triggers";
                this._httpService = httpService;
            }
            AmpTriggerService.prototype.listTriggers = function () {
                return this._httpService.listResources(this._routePrefix);
            };
            AmpTriggerService.prototype.getTrigger = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpTriggerService.prototype.createTrigger = function (trigger) {
                return this._httpService.createResource(this._routePrefix, trigger);
            };
            AmpTriggerService.prototype.updateTrigger = function (trigger, comment) {
                return this._httpService.updateResource(this._routePrefix + "/" + trigger.id + (comment ? "?comment=" + comment : ""), trigger);
            };
            AmpTriggerService.prototype.deleteTrigger = function (id) {
                return this._httpService.deleteResource(this._routePrefix + "/" + id);
            };
            AmpTriggerService.prototype.listTriggersByBundle = function (bundleId) {
                var uri = Services.AmpHttpService.makeQueryString(this._routePrefix, { bundleId: bundleId });
                return this._httpService.listResources(uri);
            };
            AmpTriggerService.IID = "AmpTriggerService";
            AmpTriggerService.$inject = [Services.AmpHttpService.IID];
            return AmpTriggerService;
        }());
        Services.AmpTriggerService = AmpTriggerService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpTypeBundleMapService = (function () {
            function AmpTypeBundleMapService(httpService) {
                this._routePrefix = "/api/typebundlemaps";
                this._httpService = httpService;
            }
            AmpTypeBundleMapService.prototype.listTypeBundleMaps = function (siteId, type) {
                var uri = Services.AmpHttpService.makeQueryString(this._routePrefix, {
                    siteId: siteId,
                    type: type
                });
                return this._httpService.listResources(uri);
            };
            AmpTypeBundleMapService.prototype.getTypeBundleMap = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpTypeBundleMapService.prototype.createTypeBundleMap = function (map) {
                return this._httpService.createResource(this._routePrefix, map);
            };
            AmpTypeBundleMapService.prototype.deleteTypeBundleMap = function (id) {
                return this._httpService.deleteResource(this._routePrefix + "/" + id);
            };
            AmpTypeBundleMapService.IID = "AmpTypeBundleMapService";
            AmpTypeBundleMapService.$inject = ["AmpHttpService"];
            return AmpTypeBundleMapService;
        }());
        Services.AmpTypeBundleMapService = AmpTypeBundleMapService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpUserSettingService = (function () {
            function AmpUserSettingService($q, httpService) {
                this._routePrefix = "/api/usersettings";
                this.$q = $q;
                this._httpService = httpService;
            }
            AmpUserSettingService.prototype.setItem = function (key, value) {
                var _this = this;
                var deferred = this.$q.defer();
                this._httpService.getResource(this._routePrefix + "?key=" + key)
                    .then(function (userSetting) {
                    if (userSetting == null) {
                        userSetting = { key: key, value: value };
                        _this._httpService
                            .createResource(_this._routePrefix, userSetting)
                            .then(function () { return deferred.resolve(); }, function (error) { deferred.reject(error); });
                    }
                    else {
                        userSetting.value = value;
                        _this._httpService
                            .updateResource(_this._routePrefix + "/" + userSetting.id, userSetting)
                            .then(function () { return deferred.resolve(); }, function (error) { deferred.reject(error); });
                    }
                }, function (error) { deferred.reject(error); });
                return deferred.promise;
            };
            AmpUserSettingService.prototype.getItem = function (key) {
                var deferred = this.$q.defer();
                this._httpService.getResource(this._routePrefix + "?key=" + key)
                    .then(function (userSetting) {
                    var value = userSetting == null ? null : userSetting.value;
                    deferred.resolve(value);
                }, function (callbackArgs) {
                    deferred.reject(callbackArgs);
                });
                return deferred.promise;
            };
            AmpUserSettingService.prototype.clear = function () {
                var deferred = this.$q.defer();
                // TODO: what does this mean?
                deferred.resolve();
                return deferred.promise;
            };
            AmpUserSettingService.prototype.removeItem = function (key) {
                var _this = this;
                var deferred = this.$q.defer();
                this._httpService.getResource(this._routePrefix + "?key=" + key)
                    .then(function (userSetting) {
                    _this._httpService.deleteResource(_this._routePrefix + "/" + userSetting.id)
                        .then(function () {
                        deferred.resolve();
                    }, function (callbackArgs) {
                        deferred.reject(callbackArgs);
                    });
                }, function (callbackArgs) {
                    deferred.reject(callbackArgs);
                });
                return deferred.promise;
            };
            AmpUserSettingService.IID = "AmpUserSettingService";
            AmpUserSettingService.$inject = ["$q", "AmpHttpService"];
            return AmpUserSettingService;
        }());
        Services.AmpUserSettingService = AmpUserSettingService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpSiteRenderIssuesService = (function () {
            function AmpSiteRenderIssuesService(httpService) {
                this._routePrefix = "/api/sites";
                this._renderSuffix = "/test/render-issues";
                this._httpService = httpService;
            }
            AmpSiteRenderIssuesService.prototype.renderIssues = function (id, store, data) {
                var resource = this._routePrefix + "/" + id + this._renderSuffix;
                if (!!store) {
                    resource = resource + "?store=true";
                }
                return this._httpService.postResourceDifferentOutput(resource, data);
            };
            AmpSiteRenderIssuesService.prototype.getRenderedIssues = function (id, peek) {
                var resource = this._routePrefix + "/" + id + this._renderSuffix;
                if (!!peek) {
                    resource = resource + "?peek=true";
                }
                return this._httpService.listResources(resource);
            };
            AmpSiteRenderIssuesService.IID = "AmpSiteRenderIssuesService";
            AmpSiteRenderIssuesService.$inject = ["AmpHttpService"];
            return AmpSiteRenderIssuesService;
        }());
        Services.AmpSiteRenderIssuesService = AmpSiteRenderIssuesService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    (function (EntityAuditAction) {
        EntityAuditAction[EntityAuditAction["Deleted"] = 0] = "Deleted";
        EntityAuditAction[EntityAuditAction["Modified"] = 1] = "Modified";
        EntityAuditAction[EntityAuditAction["Added"] = 2] = "Added";
    })(AmpCoreApi.EntityAuditAction || (AmpCoreApi.EntityAuditAction = {}));
    var EntityAuditAction = AmpCoreApi.EntityAuditAction;
    var Services;
    (function (Services) {
        var AmpEntityAuditLogService = (function () {
            function AmpEntityAuditLogService(httpService) {
                this._routePrefix = "/api/entityaudits";
                this._httpService = httpService;
            }
            AmpEntityAuditLogService.prototype.listEntityAuditLogs = function (entityId, size) {
                if (size === void 0) { size = null; }
                var resource = this._routePrefix + "/" + entityId;
                if (size !== null && size > 0) {
                    resource += "?size=" + size;
                }
                return this._httpService.getResource(resource);
            };
            AmpEntityAuditLogService.IID = "AmpEntityAuditLogService";
            AmpEntityAuditLogService.$inject = ["AmpHttpService"];
            return AmpEntityAuditLogService;
        }());
        Services.AmpEntityAuditLogService = AmpEntityAuditLogService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpVaultService = (function () {
            function AmpVaultService(httpService) {
                this.routePrefix = "/hosted/api/sites";
                this._httpService = httpService;
            }
            AmpVaultService.prototype.list = function (siteId) {
                return this._httpService.listResources(this._buildRoute(siteId));
            };
            AmpVaultService.prototype.create = function (siteId, c) {
                return this._httpService.postResource(this._buildRoute(siteId), c);
            };
            AmpVaultService.prototype.update = function (siteId, secretId, newSecret) {
                return this._httpService.postResource(this._buildRoute(siteId) + "/" + secretId, JSON.stringify(newSecret));
            };
            AmpVaultService.prototype.remove = function (siteId, secretId) {
                return this._httpService.deleteResource(this._buildRoute(siteId) + "/" + secretId);
            };
            AmpVaultService.prototype._buildRoute = function (siteId) { return this.routePrefix + "/" + siteId + "/secrets"; };
            AmpVaultService.IID = "AmpVaultService";
            AmpVaultService.$inject = [Services.AmpHttpService.IID];
            return AmpVaultService;
        }());
        Services.AmpVaultService = AmpVaultService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpCoreClusterService = (function () {
            function AmpCoreClusterService(httpService) {
                this._routePrefix = "/api/clusters";
                this._httpService = httpService;
            }
            AmpCoreClusterService.prototype.listCoreClusters = function () {
                return this._httpService.listResources(this._routePrefix);
            };
            AmpCoreClusterService.prototype.getCoreCluster = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpCoreClusterService.prototype.deleteCoreCluster = function (id) {
                return this._httpService.deleteResource(this._routePrefix + "/" + id);
            };
            AmpCoreClusterService.prototype.createCoreCluster = function (coreCluster) {
                return this._httpService.createResource(this._routePrefix, coreCluster);
            };
            AmpCoreClusterService.IID = "AmpCoreClusterService";
            AmpCoreClusterService.$inject = ["AmpHttpService"];
            return AmpCoreClusterService;
        }());
        Services.AmpCoreClusterService = AmpCoreClusterService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var ListWithSelection = (function () {
        function ListWithSelection(items, indexField) {
            if (indexField === void 0) { indexField = "id"; }
            this._indexField = indexField;
            this.setItems(items);
        }
        ListWithSelection.prototype.reindex = function () {
            if (!this._indexField) {
                return;
            }
            var n = this._items.length;
            this._itemsById = {};
            for (var i = 0; i < n; i++) {
                var item = this._items[i];
                if (item.hasOwnProperty(this._indexField)) {
                    var index = item[this._indexField];
                    if (index) {
                        this._itemsById[index] = item;
                    }
                }
            }
        };
        ListWithSelection.prototype.setItems = function (items) {
            var tempSelectedId;
            if (this._selectedItem) {
                tempSelectedId = this.selectedItem[this._indexField];
            }
            this._items = items;
            this.reindex();
            if (tempSelectedId) {
                this._selectedItem = this.getItem(tempSelectedId);
            }
        };
        ListWithSelection.prototype.isSelected = function (item) {
            return this._selectedItem === (typeof (item) === "string" ? this.getItem(item) : item);
        };
        ListWithSelection.prototype.selectItem = function (item) {
            this._selectedItem = typeof (item) === "string" ? this.getItem(item) : item;
            return this._selectedItem;
        };
        ListWithSelection.prototype.getItem = function (index) {
            return this._itemsById ? this._itemsById[index] : undefined;
        };
        ListWithSelection.prototype.getIndices = function () {
            return Object.keys(this._itemsById);
        };
        ListWithSelection.prototype.clear = function () {
            return this._items.splice(0);
        };
        ListWithSelection.prototype.contains = function (item) {
            return undefined !== (typeof (item) === "string" ? this.getItem(item) : this.getItem(item[this._indexField]));
        };
        ListWithSelection.prototype.addItem = function (item) {
            this._items.push(item);
            this.reindex();
        };
        ListWithSelection.prototype.removeItem = function (item) {
            var removeItem = typeof (item) === "string"
                ? this.getItem(item)
                : this.getItem(item[this._indexField]);
            if (this._selectedItem === removeItem) {
                this._selectedItem = null;
            }
            var i = this.items.indexOf(removeItem);
            if (i === -1)
                return;
            this.items.splice(i, 1);
            this.reindex();
        };
        Object.defineProperty(ListWithSelection.prototype, "selectedItem", {
            get: function () {
                return this._selectedItem;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ListWithSelection.prototype, "items", {
            get: function () {
                return this._items;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ListWithSelection.prototype, "length", {
            get: function () {
                return this._items.length;
            },
            enumerable: true,
            configurable: true
        });
        return ListWithSelection;
    }());
    AmpCoreApi.ListWithSelection = ListWithSelection;
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Utils = (function () {
        function Utils() {
        }
        Utils.getBuildVersionFromScriptSrc = function () {
            var buildVersion = '';
            //var buildNumberRegExp = /\/((?:[0-9]+\.){3}[0-9]+)[-\/]?/;
            //$('script').each((index, scriptElement) => {
            //    var src = $(scriptElement).attr('src');
            //    if (src.indexOf('/amp/') !== -1) {
            //        var parts = buildNumberRegExp.exec(src);
            //        if (angular.isArray(parts) && parts.length >= 2) {
            //            buildVersion = parts[1]; // Capture group
            //            return false;
            //        }
            //    }
            //});
            return buildVersion;
        };
        return Utils;
    }());
    AmpCoreApi.Utils = Utils;
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="services/ampaadappservice.ts" />
/// <reference path="services/ampaadwebsiteservice.ts" />
/// <reference path="services/ampaccountservice.ts" />
/// <reference path="services/ampazureservice.ts" />
/// <reference path="services/ampbundleservice.ts" />
/// <reference path="services/ampcoreapi.ts" />
/// <reference path="services/ampcoresecuritygroupservice.ts" />
/// <reference path="services/ampcredentialservice.ts" />
/// <reference path="services/ampdirectoryservice.ts" />
/// <reference path="services/amphttpservice.ts" />
/// <reference path="services/AmpInsightsService.ts" />
/// <reference path="services/ampkibanaconfigservice.ts" />
/// <reference path="services/amppercolatorservice.ts" />
/// <reference path="services/amppingtelemetryservice.ts" />
/// <reference path="services/ampprobeservice.ts" />
/// <reference path="services/amprdplogservice.ts" />
/// <reference path="services/amprdpsessionservice.ts" />
/// <reference path="services/amprdptelemetryservice.ts" />
/// <reference path="services/amprediscacheservice.ts" />
/// <reference path="services/ampscriptexecutionlogservice.ts" />
/// <reference path="services/ampscriptservice.ts" />
/// <reference path="services/ampsecuritylogservice.ts" />
/// <reference path="services/ampsiteissueservice.ts" />
/// <reference path="services/ampsitekibanaconfigservice.ts" />
/// <reference path="services/ampsitepercolatorservice.ts" />
/// <reference path="services/ampsiteprobeservice.ts" />
/// <reference path="services/ampsiteproviderservice.ts" />
/// <reference path="services/ampsiteproxyservice.ts" />
/// <reference path="services/ampsiteresponderservice.ts" />
/// <reference path="services/ampsiteruleservice.ts" />
/// <reference path="services/ampsitescheduleservice.ts" />
/// <reference path="services/ampsiteservice.ts" />
/// <reference path="services/ampsitetargetservice.ts" />
/// <reference path="services/ampsitedeploymentservice.ts" />
/// <reference path="services/ampsitetriggerservice.ts" />
/// <reference path="services/ampsubscriptionservice.ts" />
/// <reference path="services/amptargetservice.ts" />
/// <reference path="services/amptenantservice.ts" />
/// <reference path="services/amptimezoneservice.ts" />
/// <reference path="services/amptriggerservice.ts" />
/// <reference path="services/amptypebundlemapservice.ts" />
/// <reference path="services/ampusersettingservice.ts" />
/// <reference path="services/ampsiterenderissuesservice.ts" />
/// <reference path="services/AmpEntityAuditLogService.ts" />
/// <reference path="services/ampvaultservice.ts" />
/// <reference path="services/ampcorecluster.ts" />
/// <reference path="utils/listwithselection.ts" />
/// <reference path="app.utils.ts" />
/// <reference path="../Scripts/typings/angularjs/angular.d.ts" />
/// <reference path="../Scripts/typings/jquery/jquery.d.ts" />
/// <reference path="_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    AmpCoreApi.IID = "AmpCoreApi";
    AmpCoreApi.version = "$version$";
    // Create angular application export module and declare dependancies.
    var app = angular.module("AmpCoreApi", []);
    app.config([
        "$httpProvider", function (httpProvider) {
            httpProvider.defaults.withCredentials = true;
            httpProvider.interceptors.push([
                "$q", function (qService) {
                    var debounce = function (func, wait, immediate) {
                        var timeout;
                        return function () {
                            var _this = this;
                            var context = this, args = arguments;
                            var later = function () {
                                timeout = null;
                                if (!immediate)
                                    func.apply(_this, args);
                            };
                            var callNow = immediate && !timeout;
                            clearTimeout(timeout);
                            timeout = setTimeout(later, wait);
                            if (callNow)
                                func.apply(context, args);
                        };
                    };
                    var sessionExpiredAlert = debounce(function () {
                        //status code returned from API when user's session expires.
                        //alert("Your session has expired. Page will be reloaded");
                        //window.location.reload();
                    }, 1000, true);
                    var errorHandler = function (exception, level) {
                        var errorString = "";
                        if (exception) {
                            var rightPad = "";
                            for (var i = 0; i < level; i++) {
                                rightPad += " ";
                            }
                            if (exception.message) {
                                errorString += rightPad + "message: " + exception.message + "\n";
                            }
                            if (exception.exceptionMessage) {
                                errorString += rightPad + "exceptionMessage: " + exception.exceptionMessage + "\n";
                            }
                            if (exception.innerException) {
                                errorString += rightPad + " InnerException:\n";
                                errorString += errorHandler(exception.innerException, ++level);
                            }
                        }
                        return errorString;
                    };
                    return {
                        response: function (response) {
                            //handle IE token expiration issue. IE returns redirected page to login again
                            if (typeof response.data === "string" || response.data instanceof String) {
                                if (response.data[0] === "<" && response.data.indexOf("login.microsoftonline.com") > -1) {
                                    sessionExpiredAlert();
                                    return null;
                                }
                            }
                            return response;
                        },
                        responseError: function (rejection) {
                            if (typeof rejection === "undefined") {
                                console.error("Error: rejection is undefined.  Try checking this computer's clock is set correctly."); // Maybe user's pc clock is wrong; cert errors
                            }
                            else if (typeof rejection === "string" || rejection instanceof String) {
                                console.error("Error: " + rejection); // Maybe ADALjs error
                            }
                            else if (rejection.status === 0) {
                                sessionExpiredAlert();
                                return null;
                            }
                            else {
                                var dataString = "";
                                if (rejection.data) {
                                    if (typeof rejection.data === "string" || rejection.data instanceof String) {
                                        dataString += rejection.data;
                                    }
                                    else {
                                        dataString += "\n" + errorHandler(rejection.data, 2);
                                    }
                                }
                                console.error("Error\n" +
                                    " Status: " + rejection.status + "-" + rejection.statusText + "\n" +
                                    " Url: " + rejection.config.url + "\n" +
                                    " Data: " + dataString);
                            }
                            return qService.reject(rejection);
                        }
                    };
                }
            ]);
        }
    ]);
    app.service(AmpCoreApi.Services);
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpCoreSettingsService = (function () {
            function AmpCoreSettingsService(httpService) {
                this.routePrefix = "/api/settings";
                this.httpService = httpService;
            }
            AmpCoreSettingsService.prototype.getCoreSettings = function () {
                return this.httpService.getResource(this.routePrefix);
            };
            AmpCoreSettingsService.prototype.createCoreSettings = function (settings) {
                return this.httpService.createResource(this.routePrefix, settings);
            };
            AmpCoreSettingsService.prototype.updateCoreSettings = function (settings) {
                return this.httpService.updateResource(this.routePrefix, settings);
            };
            AmpCoreSettingsService.IID = "AmpCoreSettingsService";
            AmpCoreSettingsService.$inject = ["AmpHttpService"];
            return AmpCoreSettingsService;
        }());
        Services.AmpCoreSettingsService = AmpCoreSettingsService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpCoreSgRoleService = (function () {
            function AmpCoreSgRoleService(httpService) {
                this._routePrefix = "/api/coresgroles";
                this._httpService = httpService;
            }
            AmpCoreSgRoleService.prototype.listCoreSgRoles = function () {
                return this._httpService.listResources(this._routePrefix);
            };
            AmpCoreSgRoleService.prototype.listCoreSgRolesByGroup = function (sgId) {
                return this._httpService.listResources(this._routePrefix + "? accountId =" + sgId);
            };
            AmpCoreSgRoleService.prototype.getCoreSgRole = function (id) {
                return this._httpService.getResource(this._routePrefix + "/" + id);
            };
            AmpCoreSgRoleService.prototype.createCoreSgRoles = function (coreSg) {
                return this._httpService.createResource(this._routePrefix, coreSg);
            };
            AmpCoreSgRoleService.prototype.deleteCoreSgRoles = function (id) {
                return this._httpService.deleteResource(this._routePrefix + "/" + id);
            };
            AmpCoreSgRoleService.IID = "AmpCoreSgRoleService";
            AmpCoreSgRoleService.$inject = ["AmpHttpService"];
            return AmpCoreSgRoleService;
        }());
        Services.AmpCoreSgRoleService = AmpCoreSgRoleService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpPackageService = (function () {
            function AmpPackageService(httpService) {
                this.routePrefix = "/api/packages";
                this.httpService = httpService;
            }
            AmpPackageService.prototype.getPackages = function () {
                return this.httpService.getResource(this.routePrefix);
            };
            AmpPackageService.IID = "AmpProbeService";
            AmpPackageService.$inject = ["AmpHttpService"];
            return AmpPackageService;
        }());
        Services.AmpPackageService = AmpPackageService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    // TODO: Fill out the rest of the interfaces for the different calls
    var Services;
    (function (Services) {
        var AmpSiteElasticHealthService = (function () {
            function AmpSiteElasticHealthService(rsp) {
                this.routePrefix = "monitoring/api/v1/cluster";
                this.rsp = rsp;
            }
            AmpSiteElasticHealthService.prototype.getClusterState = function (siteId) {
                return this.rsp.getResource(siteId, this.routePrefix + "/state");
            };
            AmpSiteElasticHealthService.prototype.getClusterStateFiltered = function (siteId) {
                return this.rsp.getResource(siteId, this.routePrefix + "/state/version,master_node,nodes,blocks");
            };
            AmpSiteElasticHealthService.prototype.getClusterStats = function (siteId) {
                return this.rsp.getResource(siteId, this.routePrefix + "/stats");
            };
            AmpSiteElasticHealthService.prototype.getClusterHealth = function (siteId) {
                return this.rsp.getResource(siteId, this.routePrefix + "/health");
            };
            AmpSiteElasticHealthService.prototype.getClusterNodes = function (siteId) {
                return this.rsp.getResource(siteId, this.routePrefix + "/nodes");
            };
            AmpSiteElasticHealthService.prototype.getClusterNodeStats = function (siteId) {
                return this.rsp.getResource(siteId, this.routePrefix + "/nodes/stats");
            };
            AmpSiteElasticHealthService.IID = "AmpSiteElasticHealthService";
            AmpSiteElasticHealthService.$inject = ["AmpSiteProxyService"];
            return AmpSiteElasticHealthService;
        }());
        Services.AmpSiteElasticHealthService = AmpSiteElasticHealthService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
/// <reference path="../_references.ts" />
var AmpCoreApi;
(function (AmpCoreApi) {
    var Services;
    (function (Services) {
        var AmpSiteSoftwareService = (function () {
            function AmpSiteSoftwareService(rsp) {
                this.routePrefix = "monitoring/api/v1/software";
                this.rsp = rsp;
            }
            AmpSiteSoftwareService.prototype.getAllSoftware = function (siteId) {
                return this.rsp.getResource(siteId, this.routePrefix + "/all");
            };
            AmpSiteSoftwareService.IID = "AmpSiteSoftwareService";
            AmpSiteSoftwareService.$inject = ["AmpSiteProxyService"];
            return AmpSiteSoftwareService;
        }());
        Services.AmpSiteSoftwareService = AmpSiteSoftwareService;
    })(Services = AmpCoreApi.Services || (AmpCoreApi.Services = {}));
})(AmpCoreApi || (AmpCoreApi = {}));
